/**
 * CFilter - 页面筛选
 * @author Tevin
 */

<template>
    <view class="c-filter">
        <view
            class="c-filter-bar"
            v-if="bar"
        >
            <CFilterSelect
                v-if="bar.type==='select'"
                type="bar"
                :label="bar.label"
                :options="selectOptions[bar.name]"
                :value="filterRes[bar.name]"
                :onChange="evt=>handleChange(bar.name, evt)"
            />
        </view>
        <view
            class="c-filter-more"
            v-if="items && items.length > 0"
            @tap="evt => drawerShow=true"
        >更多筛选 »</view>
        <AtDrawer
            class="c-filter-drawer"
            mask
            right
            :show="drawerShow"
            :onClose="evt => drawerShow=false"
        >
            <scroll-view
                class="c-filter-drawer-list"
                :scrollY="true"
            >
                <view
                    class="box"
                    v-for="(item,index) of items"
                    :key="index"
                >
                    <CFilterSelect
                        v-if="item.type==='select'"
                        type="item"
                        :label="item.label"
                        :options="selectOptions[item.name]"
                        :value="filterRes[item.name]"
                        :onChange="evt=>handleChange(item.name, evt)"
                    />
                </view>
            </scroll-view>
            <view class="c-filter-drawer-btn">
                重置 完成
            </view>
        </AtDrawer>
    </view>
</template>

<script>
import Taro from '@tarojs/taro';
import { AtDrawer } from 'taro-ui-vue';
import CFilterSelect from './CFilterSelect';
import './cFilter.scss';

export default {
    name: 'CFilter',
    components: {
        AtDrawer,
        CFilterSelect,
    },
    props: {
        // 筛选横条项目
        bar: Object,
        // 筛选展开层项目列表
        items: Array,
        // 各个项目的选项列表
        selectOptions: Object,
        // 筛选变化时的回调
        onChange: Function,
    },
    data() {
        return {
            filterRes: {},
            drawerShow: false,
        };
    },
    methods: {
        handleChange(name, value) {
            this.$set(this.filterRes, name, value);
            this.onChange(this.filterRes);
        },
    },
};
</script>
